{$V-,B-,I-,A-,E-,F-,N-,O-,R-,S-}
unit calcul;
interface
uses def,def1,decoder,tpwindow,tpinline,tpstring,tpedit,tpcrt,tppick;

function calc(var val:word):bool;
{ calc : input : v_str - evaluating string
         output: val - evaluating value (if calc is true)
                 if calc is false - error detected
                                    it's position keeped in v_pos
                                    and error message keeped in err_s}
procedure w_calc;

implementation

type c_code=(c_not,
             c_mul, c_div, c_mod, c_and, c_shr, c_shl,
             c_pl, c_mn, c_or, c_xor,
             c_eq, c_ne, c_ge,c_le, c_gt, c_lt,
             c_op, c_cl, c_eof,
             c_val, c_err);

const v_str:string80='';
var v_pos:int;
    v_val:word;
    err_s:string80;
    v_er:jumprecord;

function pars:c_code;
var i:c_code; j,base:int; w:word; s:string20;
const mn:array[c_not..c_xor] of string[3]=
       ('NOT','','','MOD','AND','SHR','SHL','','','OR','XOR');
      mn1:array[c_not..c_eof] of string[2]=
       ('~','*','/','%','&','>>','<<','+','-','|',
        '','=','<>','>=','<=','>','<','(',')',#0);
begin
 while v_str[v_pos]=' ' do inc(v_pos);
 case v_str[v_pos] of
  '[':begin
       inc(v_pos);
       j:=v_pos;
       while not(v_str[v_pos] in [']',#0]) do inc(v_pos);
       s:=stupcase(trim(copy(v_str,j,v_pos-j)));
       if v_str[v_pos]=#0 then
        begin pars:=c_err; err_s:='Unexpected end of line' end else
       if not try_dig(s,v_val) then
        begin pars:=c_err; err_s:='Unknown mark' end
       else
        begin pars:=c_val; inc(v_pos) end
      end;
  'A'..'z','_':
      begin
       j:=v_pos;
       while v_str[v_pos] in ['0'..'9','A'..'z','_'] do inc(v_pos);
       s:=stupcase(copy(v_str,j,v_pos-j));
       for i:=c_not to c_xor do
        if mn[i]=s then begin pars:=i; exit end;
       if try_dig(s,v_val) then begin pars:=c_val; exit end;
       pars:=c_err; err_s:='Unknown word';
      end;
  '#':begin
       w:=0; inc(v_pos);
       if upcase(v_str[v_pos])='O' then begin base:=8; inc(v_pos) end
                                   else base:=2;
       while v_str[v_pos] in ['0'..'9'] do begin
        if ord(v_str[v_pos])-ord('0')>=base then begin
         pars:=c_err; err_s:='Illegal digit'; exit end;
        w:=w*base+ord(v_str[v_pos])-ord('0');
        inc(v_pos)
       end;
       v_val:=w; pars:=c_val
      end;
  '0'..'9':
      begin
       w:=v_pos;
       while upcase(v_str[v_pos]) in ['0'..'9','A'..'F'] do inc(v_pos);
       s:=trim(copy(v_str,w,v_pos-w));
       while v_str[v_pos]=' ' do inc(v_pos);
       if v_str[v_pos]='.' then inc(v_pos) else s:='$'+s;
       val(s,v_val,j);
       if j=0 then pars:=c_val else
        begin pars:=c_err; v_pos:=w+j-1; err_s:='Illegal digit' end;
      end;
 else begin
   for i:=c_not to c_eof do
    if (mn1[i]<>'') and
     (compstruct(mn1[i][1],v_str[v_pos],length(mn1[i]))=equal)
      then begin inc(v_pos,length(mn1[i])); pars:=i ; exit end;
   pars:=c_err; err_s:='Unknown sign'
  end
 end
end;


procedure f_err(s:string);
begin err_s:=s; longjump(v_er) end;

function get_op:c_code;
var c:c_code;
begin
 c:=pars; get_op:=c;
 case c of
  c_op, c_not, c_val: f_err('Binary operation expected');
  c_err: longjump(v_er)
 end;
end;

function prior(c:c_code):byte;
begin
 case c of
   c_mul..c_shl: prior:=4;
   c_pl..c_xor : prior:=3;
   c_eq..c_lt  : prior:=2;
   c_cl..c_eof : prior:=1;
 end
end;

function eval(var val:word):c_code;
var op:c_code;

 function get_oper:word;
 var i:word;
 begin
  case pars of
   c_mn : get_oper:=-int(get_oper);
   c_not: get_oper:= not get_oper ;
   c_op : if eval(i)=c_cl then get_oper:=i else f_err(') Expected');
   c_val: get_oper:=v_val;
   c_err: longjump(v_er);
  else f_err('Operand expected')
  end
 end;

 procedure ev(var oper1:word; var op1:c_code);
 var oper2:word; op2:c_code;
  function c(b:bool):word; begin if b then c:=$ffff else c:=0 end;
 begin
  while not (op1 in [c_eof,c_cl]) do begin
   oper2:=get_oper;
   op2:=get_op;
   if prior(op1)<prior(op2) then ev(oper2,op2);
   case op1 of
    c_mul : oper1:= oper1  *  oper2;
    c_div : oper1:= oper1 div oper2;
    c_mod : oper1:= oper1 mod oper2;
    c_and : oper1:= oper1 and oper2;
    c_shr : oper1:= oper1 shr oper2;
    c_shl : oper1:= oper1 shl oper2;
    c_pl  : oper1:= oper1  +  oper2;
    c_mn  : oper1:= oper1  -  oper2;
    c_or  : oper1:= oper1  or oper2;
    c_xor : oper1:= oper1 xor oper2;
    c_eq  : oper1:=c(oper1 =  oper2);
    c_ne  : oper1:=c(oper1 <> oper2);
    c_ge  : oper1:=c(oper1 >= oper2);
    c_le  : oper1:=c(oper1 <= oper2);
    c_gt  : oper1:=c(oper1 >  oper2);
    c_lt  : oper1:=c(oper1 <  oper2);
   end;
   op1:=op2;
  end;
 end;

begin { eval }
 val:=get_oper;
 op:=get_op;
 ev(val,op);
 eval:=op
end;

function calc(var val:word):bool;
var f_er:bool;
begin
 v_str[length(v_str)+1]:=#0;
 v_pos:=1;
 err_s:='';
 f_er:=fl;
 calc:=fl;
 setjump(v_er);
 if f_er then exit;
 f_er:=tr;
 if eval(val)<>c_eof then err_s:='Extra symbols detected' else calc:=tr;
end;


{ pick system }
type  t_pick_tp=(p_hex, p_dec, p_bin, p_octal, p_mark);

const max_pick_calc=50;
      head_pick_calc:int=1;
      total_pick_calc:int=0;
      pick_buf:string80='';
      pick_tp:t_pick_tp=p_hex;
      cur_v:word=0;

var   buf_pick_calc:array[1..max_pick_calc] of record
                                                 str:string80;
                                                 val:word
                                               end;



procedure add_pick_calc(var s:string; v:word);
begin
 with buf_pick_calc[head_pick_calc] do begin str:=s; val:=v end;
 if head_pick_calc<max_pick_calc  then inc(head_pick_calc)
                                  else head_pick_calc:=1;
 if total_pick_calc<max_pick_calc then inc(total_pick_calc);
end;

procedure sh_tp;
var s:string20;
const mn:array[t_pick_tp] of string[5]=('HEX','DEC','BIN','OCTAL','MARK');
begin
 mes('Display mode:'+mn[pick_tp],colors.atr_type);
 sh_stat:=tr;
end;

procedure next_pick_tp;
begin
 if pick_tp=p_mark then pick_tp:=p_hex else inc(pick_tp);
 sh_tp;
end;

function p_i(w:word):word;
var i:int;
begin
 i:=head_pick_calc-w;
 if i<1 then inc(i,max_pick_calc);
 p_i:=i
end;

function p_c(w:word; ful:bool):string;
var s:string20; f:bool;

 function wc(val:word; base:int):string;
 var s:string20;
 begin
  s:='';
  while val>0 do begin
   s:=chr(val and (base-1) + ord('0'))+s;
   val:=val div base
  end;
  if s='' then s:='0';
  if ful then
   if base=2 then wc:='#'+s else wc:='#O'+s
  else wc:=s
 end;

begin
 case pick_tp of
  p_hex  : p_c:=hex(w);
  p_dec  : if ful then p_c:=long2str(w)+'.' else p_c:=long2str(w);
  p_bin  : p_c:=wc(w,2);
  p_octal: p_c:=wc(w,8);
  p_mark : begin f:=fl; s:=m_name(find_mark(w,f));
             if s='' then p_c:=hex(w) else
             if ful then p_c:='[ '+s+' ]' else
             p_c:=s
           end
 end
end;

{$F+}
function get_pick_str(w:word):string;
begin
 get_pick_str:=pad(buf_pick_calc[p_i(w)].str,52)+''+
               leftpad(p_c(buf_pick_calc[p_i(w)].val,fl),16)
end;
{$F-}

function ed_pick_str:string;
begin
 ed_pick_str:=pad(cur_str,52)+''+leftpad(p_c(cur_v,fl),16)
end;

{$F+}
function pkp:word;
var i:int;
begin
 i:=total_pick_calc+4;
 if i>23 then i:=23;
 fastwrite('',i,58,col_pick_file[frameattr]);
 pkp:=readkeyword;
end;
{$F-}

procedure pick_calc;
var sv_ch:framearray; i,j:word; f:bool; sv_p:pointer;
begin
 i:=1;
 sh_tp;
 repeat
  if total_pick_calc=0 then exit;
  pickmatrix:=1;
  sv_ch:=framechars;
  setframechars('','','','','','');
  sv_p:=pickkeyptr;
  pickkeyptr:=@pkp;
  help_mes(^X^Y^[^Z' - for move. '^[' - for pick. <DEL> - for delete pick. <F2> - for switch mode');
  f:=not pickwindow(@get_pick_str,total_pick_calc,5,3,75,23,tr,col_pick_file,
                    ed_pick_str,i);
  pickkeyptr:=sv_p;
  framechars:=sv_ch;
  if f then longjump(chek_memory);
  case pickcmdnum of
   pksexit:exit;
   pksuser1:begin
       dec(total_pick_calc);
       for j:=i to total_pick_calc do
        buf_pick_calc[p_i(j)]:=buf_pick_calc[p_i(j+1)];
       if i>total_pick_calc then dec(i)
      end;
   pksuser0:begin pick_buf:=buf_pick_calc[p_i(i)].str; exit end;
   pksselect:begin pick_buf:=p_c(buf_pick_calc[p_i(i)].val,tr); exit end;
   pksuser2:next_pick_tp;
  end;
 until fl;
end;

{$F+}
function get_key_w:word;
var w:word;
begin
 repeat
  if pick_buf<>'' then begin
   get_key_w:=ord(pick_buf[1]); delete(pick_buf,1,1); exit
  end;
  w:=readkeyword;
  get_key_w:=w;
  if sh_stat=fl then begin sh_stat:=tr; sh_tp end;
  case w of
   $5000 : begin pick_calc;
            help_mes(
'Enter formula. '^[' - evaluate it, <ESC> - exit, '^Y' - Pick, <F2> - switch mode');
           end;
   $3c00 : begin
            next_pick_tp; fastwrite(''+leftpad(p_c(cur_v,fl),16),
                          3,58,col_pick_file[windowattr]);
           end;
  else exit;
  end;
 until fl
end;
{$F-}

procedure w_calc;
var s1:string80; sv_p:pointer; w:windowptr; f:bool;i:word;
begin
 if not makewindow(w,5,2,75,4,tr,tr,fl,col_pick_file[windowattr],
    col_pick_file[frameattr],0,'') or not displaywindow(w) then
           longjump(chek_memory);
 fastwrite('',2,58,col_pick_file[frameattr]);
 fastwrite('',4,58,col_pick_file[frameattr]);
 sv_p:=editkeyptr;
 editkeyptr:=@get_key_w;
 sh_tp;
 repeat
  fastwrite(''+leftpad(p_c(cur_v,fl),16),3,58,col_pick_file[windowattr]);
  s1:=v_str;
  help_mes(
   'Enter formula. '^[' - evaluate it, <ESC> - exit, '^Y' - Pick, <F2> - switch mode');
  readstring('',3,6,51,0,col_pick_file[windowattr],$70,f,v_str);
  if not (f or calc(i)) then begin
   mes('Error '+err_s,colors.err);
   init_col:=v_pos;
   pick_buf:='';
   cur_v:=0;
  end else
  begin
   cur_v:=i; if v_str<>s1 then add_pick_calc(v_str,cur_v)
  end
 until f;
 disposewindow(erasetopwindow);
 editkeyptr:=sv_p;
 show_stat;
 help;
end;
end.
