unit decoder;
interface

type m_type=(m_datab,m_dataw,m_prog,m_sub,m_exist,mm);
     { type of mark: m_data(b/w) - data label (byte or word),
                     m_prog - label of executable code
                     m_sub - label of subroutine
                     m_exist - label mast exist
                     mm - not use }

     t_getm=function(adress,curadress:word;mark_t:m_type):string;
     { function for get the label at adress 'adress' with type 'mark_t'
          (curadress - adress of comand with label used)
          result of function - string representation of label }

     t_status=(norm,term,nocode,notst,overrun,conflict);

     c_type=record
             entry:word;
             f_call,f_entry:boolean;
             f_status:t_status;
            end;
     { state of command: entry - adress of new entry point(if any);
                         f_status - type of command
                         f_call - command of call type
                         f_entry - new entry point generate }

     t_flags=(t_m1,t_com,t_byte,t_char,t_word,t_rest,t_mark,t_shift);

     t_mode=(md_simple,md_write,md_work);
     { mode of work: md_simple - not use flag filds,all adreses in hex
                     md_write  - use only flag filds for disassembling,
                                 filds not change (possible error-conflict)
                     md_work   - flag  filds may be changed,controlling
                                 the c_fix and c_update parts of filds }

     s_t_flags=set of t_flags;


  const c_prog=$80;                 { flag - executable code }
        c_data=$40;                 { flag - data area (m.b. executable too) }
        c_fix=$20;                  { flag - byte type fixed by user }
        c_entry=$10;                { flag - entry point  (m.b. label) }
        c_update=$8;                { flag - fild is controlled by decod }
        mask_type=7;                { mask for status bits(see t_flags) }
        mask_ntype=not mask_type;

function decod(var mas,flag;var adress:word;
               mode:t_mode;var ct:c_type;getm:t_getm):string;
 { dissasembling function.
    mas - array with command for decoding;
    flag - array with control information for disassembling
    adress - adress of comand(for output - adress next command);
    filds - array of entry definition;
    ct - type of command;
    getm - function for get the label;
    result of decode - assembling string of command}

function hex(w:word):string;

implementation

uses tpinline,tpstring,def;

type int=integer;
     bool=boolean;

const tr=true;
      fl=false;
      eninp:bool=tr;

var   fdddflag:(pix,piy,pno);
      accs,bufsgbyte,sbt,swd:string;
      fshift,inuse:bool;
      i,pntr:int;
      bt:byte;
      wd:word;
      error:t_status;
      break:jumprecord;
      last_mode_is_char:byte;

function hex(w:word):string;
var s:string[5]; i:int;
const hd:string[16]='0123456789ABCDEF';
begin
 i:=5;
 repeat
  s[i]:=hd[w and 15 + 1];
  w:=w shr 4;
  dec(i)
 until w=0;
 if s[i+1]>'9' then begin s[i]:='0'; dec(i) end;
 s[i]:=chr(5-i);
 hex:=string((@s[i])^)
end;

function decod(var mas,flag;var adress:word;
               mode:t_mode;var ct:c_type;getm:t_getm):string;

var memory:array[0..maxint] of byte absolute mas;
    flags :array[0..maxint] of byte absolute flag;

   function sstr(w:byte):string; var i:shortint absolute w;
    begin if i<0 then sstr:=long2str(i) else sstr:='+'+long2str(i) end;

   procedure auxget(who:t_flags;m_tp:m_type;var sbt:string);
    function w:word; type wpt=^word;
     begin wd:=wpt(@memory[pntr])^;inc(pntr);w:=wd end;
    function b:byte;begin bt:=memory[pntr]; b:=bt end;

    var mb:s_t_flags;im,rt:t_flags;i:word;as:string;
    begin
     inc(pntr);last_mode_is_char:=0;
     if mode=md_simple then begin
      if (flags[pntr] and (c_prog or c_data))<>0 then error:=conflict;
      case who of
       t_m1,t_com:bt:=b;
       t_byte,t_rest:sbt:=hexb(b)+'H';
       t_word,t_mark:swd:=hexw(w)+'H';
       t_shift:swd:=hexw(adress+2+shortint(b))+'H'
      end;
     end else begin
      case who of
       t_m1:mb:=[t_m1];
       t_com:mb:=[t_com];
       t_byte:mb:=[t_byte,t_char];
       t_rest:begin mb:=[t_byte,t_char,t_rest]; who:=t_byte end;
       t_word,t_mark:mb:=[t_word,t_mark];
       t_shift:mb:=[t_shift,t_byte];
      end;
      im:=t_flags(flags[pntr] and mask_type);
      if not(im in mb ) then
       if mode=md_write then begin rt:=who; error:=conflict end else
       if (flags[pntr] and c_fix)<>0 then
              begin error:=conflict;LongJump(break) end else
       if (flags[pntr] and c_update)<>0 then
              begin error:=overrun;LongJump(break) end else
       begin
        flags[pntr]:=(flags[pntr] and mask_ntype) or byte (who);
        if who in [t_word,t_mark] then
              flags[pntr+1]:=(flags[pntr+1] and mask_ntype) or byte (t_rest);
        rt:=who;
       end
      else rt:=im;
      as:=#0+char(lo(pntr+adress))+char(hi(pntr+adress))+char(mb);
      case rt of
       t_m1,t_com:bt:=b;
       t_byte:if who=t_byte then sbt:=as+hex(b)+'H'#0
                            else swd:=as+'$'+sstr(b+2)+#0;
       t_char:begin sbt:=as+''''+char(b)+''''#0; last_mode_is_char:=1 end;
       t_rest: last_mode_is_char:=2;
       t_word:swd:=as+hex(w)+'H'#0;
       t_mark,t_shift:begin
          if rt=t_mark then i:=w else i:=adress+2+shortint(b);
          if mode=md_write then begin
           swd:=getm(i,adress,m_exist);
           if swd='' then swd:=hex(i)+'H';
          end else
          if im in [t_mark,t_shift] then swd:=getm(i,adress,m_exist)
                                    else swd:=getm(i,adress,m_type(m_tp));
          swd:=as+swd+#0;
         end
      end
     end
    end;

   function sgbyte:string;
    var c,ch:char;i:shortint;b:byte;f:bool; p:ptr_mark_tree; s:string20;
    const a:s_t_flags=[t_byte,t_char,t_rest];
    begin
     b:=bt;
     if bufsgbyte='' then begin
      auxget(t_rest,mm,bufsgbyte);
      if last_mode_is_char=1 then begin
       if memory[2]<$80 then ch:='+' else ch:='-';
       if mode=md_simple then
        sgbyte:=char(abs(shortint(memory[2])))+''''
       else
        sgbyte:=#0+char(lo(2+adress))+char(hi(2+adress))+char(a)+ch+
                         ''''+char(abs(shortint(memory[2])))+''''#0;
      end else
      if last_mode_is_char=2 then begin
        f:=fl;
        p:=find_mark(adress,f);
        if p=nil then
         s:='+???' else
        s:='+'+get_shift(byte(memory[2]),p^.key);
        if s='+' then s:='+???';
        if mode=md_simple then
         sgbyte:=s
        else
         sgbyte:=#0+char(lo(2+adress))+char(hi(2+adress))+char(a)+s+#0
      end else
        if mode=md_simple then
         sgbyte:=sstr(memory[2])
        else
         sgbyte:=#0+char(lo(2+adress))+char(hi(2+adress))+char(a)+
                 sstr(memory[2])+#0
     end else sgbyte:=bufsgbyte;
     bt:=b
    end;

   procedure get(who:t_flags;m_tp:m_type);
    begin
     if fshift and (pntr=1) then bufsgbyte:=sgbyte;
     auxget(who,m_tp,sbt)
    end;

   function reg(a:byte):string;
    begin
     case a and 7 of
      0:reg:='B';
      1:reg:='C';
      2:reg:='D';
      3:reg:='E';
      7:reg:='A';
      4:if eninp then
         case fdddflag of
          pix:begin reg:='HX';inuse:=tr;ct.f_status:=notst;fshift:=fl end;
          piy:begin reg:='HY';inuse:=tr;ct.f_status:=notst;fshift:=fl end;
          pno:reg:='H'
         end
        else reg:='H';
      5:if eninp then
         case fdddflag of
          pix:begin reg:='LX';inuse:=tr;ct.f_status:=notst;fshift:=fl end;
          piy:begin reg:='LY';inuse:=tr;ct.f_status:=notst;fshift:=fl end;
          pno:reg:='L'
         end
        else reg:='L';
      6:case fdddflag of
         pix:begin reg:='(IX'+sgbyte+')';inuse:=tr end;
         piy:begin reg:='(IY'+sgbyte+')';inuse:=tr end;
         pno:reg:='(HL)'
        end;
     end
    end;

   function reg2(r:byte):string;
    begin
     eninp:=((r and $38)<>$30) and ((r and 7)<>6);
     reg2:=reg(r shr 3)+','+reg(r);
     eninp:=tr
    end;

   function cond(a:byte):string;
    begin
     case a and 7 of
      0:cond:='NZ';
      1:cond:='Z';
      2:cond:='NC';
      3:cond:='C';
      4:cond:='PO';
      5:cond:='PE';
      6:cond:='P';
      7:cond:='M'
     end
    end;

   function rp(a:byte;useaf:bool):string;
    begin
     case a and 3 of
      0:rp:='BC';
      1:rp:='DE';
      2:begin inuse:=tr;
         case fdddflag of
          pix:begin rp:='IX';fshift:=fl end;
          piy:begin rp:='IY';fshift:=fl end;
          pno:rp:='HL'
         end
        end;
      3:if useaf then rp:='AF' else rp:='SP'
     end
    end;

   function ariph(a:byte):string;
    begin
     case (a shr 3) and 7 of
      0:ariph:='ADD A,';
      1:ariph:='ADC A,';
      2:ariph:='SUB ';
      3:ariph:='SBC A,';
      4:ariph:='AND ';
      5:ariph:='XOR ';
      6:ariph:='OR ';
      7:ariph:='CP ';
     end;
    end;

   procedure notcom;
    begin
     ct.f_status:=nocode;
     accs:='DB '+hex(memory[0])+'H'
    end;

   procedure prefed;
    begin
     get(t_com,mm);
     case bt of
      $a0:accs:='LDI';
      $a1:accs:='CPI';
      $a2:accs:='INI';
      $a3:accs:='OUTI';
      $b0:accs:='LDIR';
      $b1:accs:='CPIR';
      $b2:accs:='INIR';
      $b3:accs:='OTIR';
      $44:accs:='NEG';
      $46:accs:='IM 0';
      $56:accs:='IM 1';
      $5e:accs:='IM 2';
      $47:accs:='LD I,A';
      $57:accs:='LD A,I';
      $67:accs:='RRD';
      $4f:accs:='LD R,A';
      $5f:accs:='LD A,R';
      $6f:accs:='RLD';
      $a8:accs:='LDD';
      $a9:accs:='CPD';
      $aa:accs:='IND';
      $ab:accs:='OUTD';
      $b8:accs:='LDDR';
      $b9:accs:='CPDR';
      $ba:accs:='INDR';
      $bb:accs:='OTDR';
      $45:begin accs:='RETN'; ct.f_status:=term end;
      $4d:begin accs:='RETI'; ct.f_status:=term end;
      $70:accs:='IN F,(C)';
      $71:notcom;
     else
      case bt and $c7 of
       $40:accs:='IN '+reg(bt shr 3)+',(C)';
       $41:accs:='OUT (C),'+reg(bt shr 3);
      else
       case bt and $cf of
        $4a:accs:='ADC HL,'+rp(bt shr 4,fl);
        $42:accs:='SBC HL,'+rp(bt shr 4,fl);
        $4b:begin accs:='LD '+rp(bt shr 4,fl)+',(';get(t_mark,m_dataw);
                  accs:=accs+swd+')';
            end;
        $43:begin accs:=rp(bt shr 4,fl);get(t_mark,m_dataw);
                  accs:='LD ('+swd+'),'+accs;
            end;
       else notcom;
       end
      end
     end
    end;

   procedure prefcb;
    function c:string; begin c:=chr(((bt shr 3) and 7)+$30)+',' end;
    function mnem:string;
     begin
      case (bt shr 3) and 7 of
       0:mnem:='RLC';
       1:mnem:='RRC';
       2:mnem:='RL';
       3:mnem:='RR';
       4:mnem:='SLA';
       5:mnem:='SRA';
       6:begin mnem:='SRI';ct.f_status:=notst end;
       7:mnem:='SRL';
      end;
     end;

    begin
     get(t_com,mm);
     case bt and $c0 of
      $40:accs:='BIT '+c+reg(bt);
      $c0:if (fdddflag<>pno) and ((bt and 7)<>6) then
           begin accs:='SETL '+reg(bt)+','+c+reg(6);ct.f_status:=notst end
          else accs:='SET '+c+reg(bt);
      $80:if (fdddflag<>pno) and ((bt and 7)<>6) then
           begin accs:='RESL '+reg(bt)+','+c+reg(6);ct.f_status:=notst end
          else accs:='RES '+c+reg(bt);
        0:if (fdddflag<>pno) and ((bt and 7)<>6) then
           begin accs:=mnem+'L '+reg(bt)+','+reg(6);ct.f_status:=notst end
          else accs:=mnem+' '+reg(bt);
     else notcom
     end
    end;

 begin
  pntr:=-1; inuse:=fl; fdddflag:=pno; ct.f_status:=norm; fshift:=fl;
  error:=norm; ct.f_call:=fl; ct.f_entry:=fl;bufsgbyte:='';
  SetJump(break);
  if error=norm then begin
     get(t_m1,mm);
     if bt in [$fd,$dd] then begin
      fshift:=tr;
      if bt=$dd then fdddflag:=pix else fdddflag:=piy;
      get(t_com,mm);
     end;
     case bt of
      $ed:prefed;
      $cb:prefcb;
        0:accs:='NOP';
        7:accs:='RLCA';
      $17:accs:='RLA';
      $27:accs:='DAA';
      $37:accs:='SCF';
      $76:begin accs:='HALT';ct.f_status:=term end;
      $f3:accs:='DI';
        8:accs:='EX AF,AF''';
       $f:accs:='RRCA';
      $1f:accs:='RRA';
      $2f:accs:='CPL';
      $3f:accs:='CCF';
      $fb:accs:='EI';
      $d9:accs:='EXX';
      $eb:accs:='EX DE,HL';
       $a:accs:='LD A,(BC)';
      $1a:accs:='LD A,(DE)';
      $2a:begin get(t_mark,m_dataw); accs:='LD '+rp(2,tr)+',('+swd+')'; end;
      $3a:begin get(t_mark,m_datab); accs:='LD A,('+swd+')'; end;
        2:accs:='LD (BC),A';
      $12:accs:='LD (DE),A';
      $22:begin get(t_mark,m_dataw); accs:='LD ('+swd+'),'+rp(2,tr); end;
      $32:begin get(t_mark,m_datab); accs:='LD ('+swd+'),A'; end;
      $10:begin get(t_shift,m_prog); accs:='DJNZ '+swd;
                ct.f_entry:=tr; ct.entry:=adress+2+shortint(bt);
          end;
      $20:begin get(t_shift,m_prog);accs:='JR NZ,'+swd;
                ct.f_entry:=tr; ct.entry:=adress+2+shortint(bt);
          end;
      $30:begin get(t_shift,m_prog);accs:='JR NC,'+swd;
                ct.f_entry:=tr; ct.entry:=adress+2+shortint(bt);
          end;
      $28:begin get(t_shift,m_prog); accs:='JR Z,'+swd;
                ct.f_entry:=tr; ct.entry:=adress+2+shortint(bt);
          end;
      $38:begin get(t_shift,m_prog); accs:='JR C,'+swd;
                ct.f_entry:=tr; ct.entry:=adress+2+shortint(bt);
          end;
      $18:begin get(t_shift,m_prog); accs:='JR '+swd;ct.f_status:=term;
                ct.f_entry:=tr; ct.entry:=adress+2+shortint(bt);
          end;
      $c9:begin accs:='RET'; ct.f_status:=term; end;
      $e9:begin accs:='JP ('+rp(2,tr)+')'; ct.f_status:=term; end;
      $f9:accs:='LD SP,'+rp(2,tr);
      $e3:accs:='EX (SP),'+rp(2,tr);
      $db:begin get(t_byte,mm); accs:='IN A,('+sbt+')'; end;
      $d3:begin get(t_byte,mm); accs:='OUT ('+sbt+'),A'; end;
      $c3:begin get(t_mark,m_prog); accs:='JP '+swd;ct.f_entry:=tr;
                ct.f_status:=term; ct.entry:=wd end;
      $cd:begin get(t_mark,m_sub); accs:='CALL '+swd;ct.f_entry:=tr;
                ct.f_call:=tr;ct.entry:=wd end;
     else {case}
      case bt and $c0 of
       $40:accs:='LD '+reg2(bt);
       $80:accs:=ariph(bt)+reg(bt)
      else
       case bt and $c7 of
        6  :begin accs:=reg(bt shr 3); get(t_byte,mm);
                  accs:='LD '+accs+','+sbt end;
        $c6:begin accs:=ariph(bt); get(t_byte,mm); accs:=accs+sbt end;
        $4 :accs:='INC '+reg(bt shr 3);
        $5 :accs:='DEC '+reg(bt shr 3);
        $c2:begin get(t_mark,m_prog);accs:='JP '+cond(bt shr 3)+','+swd;
                  ct.f_entry:=tr; ct.entry:=wd
            end;
        $c4:begin get(t_mark,m_sub);accs:='CALL '+cond(bt shr 3)+','+swd;
                  ct.f_entry:=tr;ct.f_call:=tr;ct.entry:=wd
            end;
        $c0:accs:='RET '+cond(bt shr 3);
        $c7:begin accs:='RST '+hex(bt and $38)+'H';ct.f_entry:=tr;
                  ct.entry:=bt and $38;ct.f_call:=tr;
                  getm(bt and $38,adress,m_sub);
            end;
       else
        case bt and $cf of
         1  :begin accs:='LD '+rp(bt shr 4,fl)+',';get(t_word,m_exist);
                   accs:=accs+swd
             end;
         $c5:accs:='PUSH '+rp(bt shr 4,tr);
         $c1:accs:='POP '+rp(bt shr 4,tr);
         $9 :accs:='ADD '+rp(2,fl)+','+rp(bt shr 4,fl);
         $3 :accs:='INC '+rp(bt shr 4,fl);
         $b :accs:='DEC '+rp(bt shr 4,fl);
        else notcom;
        end { cf }
       end { c7 }
      end { c0 }
     end { case };
     if (fdddflag <> pno) and not inuse then notcom;
  end; { error }
  if ct.f_status=nocode then begin
   if mode=md_work then
    flags[0]:=(flags[0] and mask_ntype) or (c_prog or c_data or c_update
                                           or byte(t_byte));
   inc(adress) end else
  if error=norm then begin
   if mode=md_work then
     for i:=0 to pntr do flags[i]:=flags[i] or (c_prog or c_update);
   inc(adress,pntr+1) end else
  begin
   ct.f_status:=error;
   if mode=md_work then for i:=0 to pntr-1 do
     flags[i]:=flags[i] or (c_prog or c_update or c_data);
   inc(adress,pntr)
  end;

  decod:=accs
 end;

 end.
